#include <stdio.h>
#include "winsock.h" // nekdy nutno pouzit winsock.h

#define ECHOPORT	5566
#define BUFFSIZE	128

void main(int argc, char *argv[]) {

	// Initialize Winsock.
	WSADATA wsaData;
	int iResult = WSAStartup( MAKEWORD(2,2), &wsaData );
	if ( iResult != NO_ERROR ) {
		printf("Error at WSAStartup()\n");
		getchar();
		return;
	}

	// Create a socket.
	SOCKET m_socket;
	m_socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );

	if ( m_socket == INVALID_SOCKET ) {
		printf( "Error at socket(): %ld\n", WSAGetLastError() );
		WSACleanup();
		getchar();
		return;
	}

	// Bind the socket.
	sockaddr_in service;

	service.sin_family = AF_INET;
	service.sin_addr.s_addr = inet_addr( "127.0.0.1" );
	service.sin_port = htons( ECHOPORT );

	if ( bind( m_socket, (SOCKADDR*) &service, sizeof(service) ) == SOCKET_ERROR ) {
		printf( "bind() failed.\n" );
		closesocket(m_socket);
		getchar();
		return;
	}

	// Listen on the socket.
	if ( listen( m_socket, 1 ) == SOCKET_ERROR ) {
		printf( "Error listening on socket.\n");
		getchar();
		return;
	}

	// Accept connections.
	SOCKET AcceptSocket;

   while(true) {
		printf( "Waiting for a client to connect...\n" );
		AcceptSocket = SOCKET_ERROR;
		while ( AcceptSocket == SOCKET_ERROR ) {
			AcceptSocket = accept( m_socket, NULL, NULL );
		}
		printf( "Client Connected.\n");

		// Send and receive data.
		int bytesRecv = SOCKET_ERROR;
		char recvbuf[BUFFSIZE+1] = "";

		int bytes = 0;
		while( bytesRecv != 0 ) {
			bytesRecv = recv( AcceptSocket, recvbuf, BUFFSIZE, 0 );
			if (bytesRecv == WSAECONNRESET ) {
				printf( "Connection Closed.\n");
 				getchar();
				break;
			}
			if (bytesRecv < 0) {
				printf("Error");
				getchar();
				return;
			}
			bytes += bytesRecv;
			recvbuf[bytesRecv] = 0;
			printf("%s", recvbuf);
		}
		printf( "\n\nConnection Closed.\n");
		printf( "Bytes Recv: %ld\n", bytes);

		closesocket(AcceptSocket);
   }
}
